package demo.pay.api.controller;

import demo.pay.api.model.PayModel;
import demo.pay.api.util.PayUtil;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.transform.Result;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.HashMap;
import java.util.Map;

@Controller
@RequestMapping("/pay")
public class PayController {

	@RequestMapping("/pay")
	@ResponseBody
	public Map<String, Object> pay(HttpServletRequest request, float money, String pay_type) {
		Object pt = pay_type;
		Map<String, Object> resultMap = new HashMap<String, Object>();
		Map<String, Object> remoteMap = new HashMap<String, Object>();
		//格式化两位小数是不
		NumberFormat numberFormat = new DecimalFormat("###.00");
		remoteMap.put("money", numberFormat.format(money));
		remoteMap.put("pay_type", pt);
		remoteMap.put("order_no", PayUtil.getOrderIdByUUId());
		remoteMap.put("subject", "goodsname");
		remoteMap.put("app_id", PayUtil.APP_ID);
		remoteMap.put("extra", "");
		resultMap.put("data", PayUtil.payOrder(remoteMap));
		return resultMap;
	}

//	public static void main(String[] args) {
//		NumberFormat numberFormat = new DecimalFormat("###.00");
//		System.out.println(numberFormat.format(222));
//	}


	@RequestMapping("/notifyPay")
	public void notifyPay(HttpServletRequest request, HttpServletResponse response, PayModel payModel) throws IOException {
		// 保证密钥一致性
		if (PayUtil.checkSign(payModel)) {
			// TODO 支付成功的业务处理
			//这里业务处理
			//如果支付金额是前端传递过来的，这里还要验证支付金额
			
			response.getWriter().println("success");
		} else {
			// 签名错误
			response.getWriter().println("签名错误");
		}
	}

	@RequestMapping("/returnPay")
	public void returnPay(HttpServletRequest request, HttpServletResponse response, PayModel payModel) throws IOException {
		// 保证密钥一致性
		if (PayUtil.checkSign(payModel)) {
			// 建议本面仅显示支付结果,支付成功的业务处理放在如上的notifyPay里			
			response.getWriter().println("恭喜支付成功！订单号：" + payModel.getOrder_no());
		} else {
			// 签名错误
			response.getWriter().println("签名错误");
		}
	}

	/**
	 * 控制器内部的异常处理
	 * @param e
	 * @return
	 */
	@ResponseBody
	@ExceptionHandler(Exception.class)
	public Result handleException(Exception e) {
		System.out.println("打印");
		e.printStackTrace();
		return new Result() {
			@Override
			public void setSystemId(String systemId) {

			}

			@Override
			public String getSystemId() {
				return null;
			}
		};
	}

}
